//
//  UIViewArKit.swift
//  ArkitDoushiQi
//
//  Created by Enzo JOLYS on 12/06/2024.
//

import SwiftUI
import DouShouQiModel

struct UIViewArKit: View {
    
    var game:Game = try! Game(withRules: ClassicRules(), andPlayer1: HumanPlayer(withName: "Bot1", andId: .player1)!, andPlayer2: RandomPlayer(withName: "Bot2", andId: .player2)!)

    
    @State var msg:String = "Msg"
    
    var body: some View {
        VStack {
            Text(msg)
            ArKitViewRepresentable(game)
                .ignoresSafeArea()
                .navigationBarBackButtonHidden(true)
                .task {
                    game.addGameStartedListener { board in startGame()}
                    game.addGameOverListener { board, result, player in gameOver() }
                    game.addGameChangedListener { game in gameChange() }

                    game.addMoveChosenCallbacksListener { board, move, player in moveChose(board: board, move: move, player: player) }
                        
                    game.addPieceRemovedListener { _,_,piece in removePiece(piece: piece) }
                    
                    game.addPlayerNotifiedListener { board, player in
                        print("Player notif : \(player.id) à toi de jouer ")
                        msg = "Player notif : \(player.id) à toi de jouer !"
                        
                        if (player is IAPlayer ){
                            try! await player.chooseMove(in: board, with: game.rules)
                        }
                    }
                    
                    //try! await game.start()
                }
        }
    }
    
    // ------ Listener -------- //
    
    func startGame() { print("Start game !")
        msg = "Start !!"
    }
    func gameOver() { print("Game over !")
        msg = "Game over !!"
    }
    func gameChange() { print("Game change !") }
    
    func moveChose(board:Board,move:Move,player:Player) {
    }
    
    func removePiece(piece:Piece){
        msg = "Piece manger !!"
    }
    
    
    // ------------------------- //
}


struct UIViewArKit_Previews: PreviewProvider {
    static var previews: some View {
        UIViewArKit()
    }
}
